--Coded by Mejina (Dethecus) 2008

local elapsedTime = 0;
local zoneTimer = 15;
local loadTimer = 40;
local timerOffset = 1.000;
local trem = 0;
local status = "";
local control = "";

local wtStartHonor = GetHonorCurrency();
local wtStartKill = GetPVPLifetimeStats();

local wintertimeGC = "WinterTimeGlobal";
local validateString = "5th0oi98gj34";
local channelsLoaded = false

local guildDelay = 0;
local guildTable = {};
local guildText = "";

local debug = false;

local version = "1.64";
local newver = version;
local verDisplay = false;
local vCount = 0;

local validSTime = true;
local endTime = -9999999;
local syncSent = false;
local loadCycles = 0;

local syncTimer = 120;
local mapUpdateDelay = 2;

local guildMessageDelay = 0;
local announceDelay = 0;

local inWg = false;

WinterTimeScale = 1;
WinterTimeAlpha = 100;
WinterTimeCheck = 1;
WinterTimeGuildA = 1;
WTTextColorR = 1
WTTextColorG = 1
WTTextColorB = 1
WinterTimeLockMovement = 0;
WinterTimeShowColor = 1;
WinterTimePVPTab = 1;

local mouse = "";

function WinterTime_OnLoad()
	if( DEFAULT_CHAT_FRAME ) then
		DEFAULT_CHAT_FRAME:AddMessage("|c003333ffWinterTime|r v"..version.." Loaded.");
	end
    
	this:RegisterEvent("GOSSIP_SHOW");
	this:RegisterEvent("CHAT_MSG_CHANNEL");
	this:RegisterEvent("CHAT_MSG_ADDON");
	this:RegisterEvent("CHAT_MSG_CHANNEL_NOTICE");
	this:RegisterEvent("CHAT_MSG_MONSTER_YELL");
	this:RegisterEvent("CHAT_MSG_GUILD");
	this:RegisterEvent("PLAYER_LOGIN");
    this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("CHAT_MSG_WHISPER");
    this:RegisterEvent("PLAYER_LOGOUT");
    this:RegisterEvent("WORLD_MAP_UPDATE");
    this:RegisterEvent("HONOR_CURRENCY_UPDATE");
    this:RegisterEvent("PLAYER_PVP_KILLS_CHANGED");
    
    

   	SlashCmdList["WinterTimeCOMMAND"] = WinterTime_Handler;
   	SLASH_WinterTimeCOMMAND1 = "/wt";
   	SLASH_WinterTimeCOMMAND2 = "/wintertime";

    tinsert(UISpecialFrames,"WTOptions");

	WTForm:SetHeight(60)
	WTForm:SetWidth(130)
    
    WTOptions:SetHeight(340);
    WTOptions:SetWidth(300);

	WTFormCloseButton:Hide();
	WTAnnounceButton:Hide();
    
    WTForm:SetScale(WinterTimeScale);
    WTForm:SetAlpha(WinterTimeAlpha);
    
    WTLabel:SetScale(WinterTimeScale);
    
    WTOptionsSliderScale:SetValue(WinterTimeScale);
    WTOptionsSliderAlpha:SetValue(WinterTimeAlpha);
    
    if (WinterTimeCheck == 1) then
        WTOptionsCheckButton:SetChecked(true);
        WTForm:Show();
        WTLabel:Show();
    else
        WTOptionsCheckButton:SetChecked(false);
        WTForm:Hide();
        WTLabel:Hide();
    end
    
    if (WinterTimeGuildA == 1) then
        WTOptionsGuildCheck:SetChecked(true);
    else
        WTOptionsGuildCheck:SetChecked(false);
    end
    
    if (WinterTimeLockMovement == 1) then
        WTOptionsLockMove:SetChecked(true);
    else
        WTOptionsLockMove:SetChecked(false);
    end
    
    if (WinterTimeShowColor == 1) then
        WTOptionsShowColor:SetChecked(true);
    else
        WTOptionsShowColor:SetChecked(false);
    end
    
    if (WinterTimePVPTab == 1) then
        WTOptionsShowPVPTab:SetChecked(true);
    else
        WTOptionsShowPVPTab:SetChecked(false);
    end
    
    ColorPickerFrame:SetColorRGB(WTTextColorR, WTTextColorG, WTTextColorB);
    WTLabel:SetTextColor(WTTextColorR, WTTextColorG, WTTextColorB);

    UIDropDownMenu_SetWidth(WTAnnounceButton, 9)
    WTAnnounceButton:SetScale(.79);
    
    WTFormPVP:SetHeight(40);
    WTFormPVP:Hide();
    
    WTAuthorLbl:SetText("Coded by Mejina (Delegated Authority) Dethecus");
end

function WinterTime_OnUpdate(elapse)
    elapsedTime = elapsedTime + elapse;

    if (GetZoneText() == "Wintergrasp" and WTFormPVP:GetHeight()<80 and WinterTimePVPTab == 1) then
        WTFormPVP:Show();
        WTFormPVP:SetHeight(WTFormPVP:GetHeight()+1);
        wtStartHonor = GetHonorCurrency();
        wtStartKill = GetPVPLifetimeStats();
        WTKillCount:SetText("0");
        WTHonorCount:SetText("0");
        if GetHonorCurrency() == 75000 then
            WTHonorCount:SetText("MAX");
        end
        if WTFormPVP:GetHeight()>60 then
            WTKillText:Show();
            WTKillCount:Show();
        end
    elseif (WTFormPVP:GetHeight()>40 and (GetZoneText() ~= "Wintergrasp" or WinterTimePVPTab==0))  then
        WTHonorText:Hide();
        WTHonorCount:Hide();
        if WTFormPVP:GetHeight() <65 then
            WTKillText:Hide();
            WTKillCount:Hide();
        end
        if WTFormPVP:GetHeight()>=80 then
            englishFaction, localizedFaction = UnitFactionGroup("player");
            local honor = GetHonorCurrency() - wtStartHonor;
            local kills = GetPVPLifetimeStats()-wtStartKill;
            if kills > 0 and honor >0 then
                chatmsg("|c003333ff[WinterTime]|r  You killed "..kills.." enemies and gained "..honor.." honor while in Wintergrasp. Glory to the "..englishFaction.."!");
            elseif kills > 0 then
                chatmsg("|c003333ff[WinterTime]|r  You killed "..kills.." enemies while in Wintergrasp. Glory to the "..englishFaction.."!");
            elseif honor > 0 then
                chatmsg("|c003333ff[WinterTime]|r  You gained "..honor.." honor while in Wintergrasp. Glory to the "..englishFaction.."!");
            end
        end
        
        WTFormPVP:SetHeight(WTFormPVP:GetHeight()-1);
    elseif WTFormPVP:GetHeight()<=40 then
        WTFormPVP:Hide();
    elseif WTFormPVP:GetHeight()>=80 then
        WTHonorText:Show();
        WTHonorCount:Show();
    end
    
    
    

    if (elapsedTime > 1) then
    
        elapsedTime = elapsedTime - 1;
        guildDelay = guildDelay - 1;
        guildMessageDelay = guildMessageDelay - 1;
        announceDelay = announceDelay - 1;
        syncTimer = syncTimer - 1;
        
        if GetWintergraspWaitTime then
            local nextBattleTime = GetWintergraspWaitTime();
            if not WorldMapFrame:IsVisible() then
                SetMapToCurrentZone();
            end
            if ((syncTimer < 0) and nextBattleTime and (GetCurrentMapContinent()==4)) then
                status = "Next"
                WinterTime_UpdateGlobal(nextBattleTime)
            end
        end
        
        if (guildDelay == 0 ) then
            table.sort(guildTable);
            if (debug == true) then
                chatmsg(table.concat(guildTable, ", "));
            end
            if (guildTable[1] == UnitName("player")) then
                if (GetGuildInfo("player") ~= nil) then
                    if (guildMessageDelay < 0) then
                        --WTsendMessage("GUILD");
                        --SendChatMessage(guildText, "GUILD");
                        WTsendMessage("GUILD", nil, guildText);
                        
                        guildMessageDelay = 30;
                    else
                        wtDebug("Can't auto-announce yet, "..guildMessageDelay);
                    end
                end
            end
        end
        
        loadTimer = loadTimer - 1;
        
        if debug and loadTimer > -5 then
            --chatmsg(loadTimer);
        end
        
        if (loadTimer == 9) then
            id, name = GetChannelName(1);
            if (name == nil) then
                loadTimer = 14;
                wtDebug("no channel 1 yet, waiting another 5 seconds.");
            else
                WinterTime_RegChannel();
                --id, name = GetChannelName(wintertimeGC);
                --chatglobmsg("version:"..version);
            end
        end
        
        if (loadTimer == 5) then
            if debug then
                --id, name = GetChannelName(wintertimeGC);
                --chatmsg("Sending Version to "..id)
            end
            --id, name = GetChannelName(wintertimeGC)
            --chatglobmsg("version:"..version);
        end
        
        if (loadTimer == 5) then
            id, name = GetChannelName(wintertimeGC);
            if (id == nil or name == nil) then
                loadTimer = 15;
                return;
            end
            chatglobmsg("version:"..version);
            chatglobmsg("sync");
        end
        
        if (loadTimer == -5) then
            if (not syncSent) then
                if (loadCycles >=2) then
                    chatglobmsg("version:"..version);
                    chatglobmsg("sync");
                    loadCycles = 0;
                end
                loadTimer = 4;
                loadCycles = loadCycles+1;
                wtDebug("Cycle: "..loadCycles);
                return;
            end
        
            if (newver ~= version) then
                chatmsg("|c003333ff[WinterTime]|r New version "..newver.." available.");
                WTOptionsVersionLbl:SetText("New version "..newver.." available.");
            end
            if trem <0 then
                syncTimer = 5;
                zoneTimer = 1;
            end
            wtDebug("Version returned, found "..newver);

        end
    
        zoneTimer = zoneTimer-1;
        
        if (debug == true and zoneTimer>-1) then
            --wtDebug(zoneTimer);
        end
        
        if (zoneTimer == 0) then	
            --wtDebug(GetZoneText());

            
            if (GetZoneText() == "Dalaran") then
                zoneTimer = 30;
            end
            
            if (GetZoneText() == "Wintergrasp") then
                zoneTimer = 30;
                if (select(2,GetWorldStateUIInfo(8))~=0) then
                    if (select(3,GetWorldStateUIInfo(8))~=nil) then
                        txt = select(3,GetWorldStateUIInfo(8))..".";
                        if select(2,GetWorldStateUIInfo(7)) == 1 then
                            control = "Horde";
                        elseif select(2,GetWorldStateUIInfo(6)) == 1 then
                            control = "Alliance";
                        else
                            control = "";
                        end
                        status = "Next";
                        extractTime(txt);
                    end
                else
                    if (select(3,GetWorldStateUIInfo(8))~=nil) then
                        txt = select(3,GetWorldStateUIInfo(8))..".";
                        status = "Battle";
                        extractTime(txt);
                    end
                end
            end
        end
    
        if (trem == nil) then
                wtDebug("Trem = nil, first");
                wtDebug("Attempting to resync.....");
            trem = -2;
            chatglobmsg("sync");
        end
    
        --trem = trem -1;
        
        --trem = endTime - serverTimeSeconds();
        trem = timeBetween(endTime, serverTimeSeconds());
        
    
        if (trem > 0) then
            WTLabel:SetText(status..":  "..convertTime(trem).." ")
         else
            control = "";
            WTLabel:SetText(" ");
        end
        
        if (control == "Horde" and WinterTimeShowColor == 1) then
            TitleText:SetTextColor(1,0,0) 
        elseif (control == "Alliance" and WinterTimeShowColor == 1) then
            TitleText:SetTextColor(0,0,1) 
        else
            TitleText:SetTextColor(1,0.8196079,0) 
        end
    
        if (status == "Next") then
            if (trem == (60*60)) then
                chatmsg("|c003333ffWintergrasp|r in 1 hour.");
            end
            if (trem == (30*60+1)) then
                chatmsg("|c003333ffWintergrasp|r in 30 minutes.");
                if (WinterTimeGuildA == 1) then
                    guildmsg(generateMessage(trem -1));
                else
                    wtDebug("Auto-announce aborted.");
                end
            end
            if (trem == (15*60+1)) then
                chatmsg("|c003333ffWintergrasp|r in 15 minutes.");
                if (WinterTimeGuildA == 1) then
                    guildmsg(generateMessage(trem -1))
                    --guildmsg("[WAPNER] Battle in "..convertTime(trem-1)..".");
                else
                    wtDebug("Auto-announce aborted.");
                end
            end
            if (trem == (10*60)) then
                chatmsg("|c003333ffWintergrasp|r in 10 minutes.");
            end
            if (trem == (5*60+1)) then
                chatmsg("|c003333ffWintergrasp|r in 5 minutes.");
                if (WinterTimeGuildA == 1) then
                    guildmsg(generateMessage(trem -1))
                    --guildmsg("[WAPNER] Battle in "..convertTime(trem-1)..".");
                else
                    wtDebug("Auto-announce aborted.");
                end
            end
            if (trem == (1)) then
                chatmsg("|c003333ffWintergrasp|r Battle has begun!");
                if (WinterTimeGuildA == 1) then
                    guildmsg("[WAPNER] The "..battleType().."battle has begun!");
                else
                    wtDebug("Auto-announce aborted.");
                end

                trem = 30*60;
                endTime = endTimeServer(trem)
                status = "Battle";
                --control = "";
            end
        else
            --control = "";
        end
    end
end

function WinterTime_RegChannel()
	JoinTemporaryChannel(wintertimeGC);
	RemoveChatWindowChannel(1, wintertimeGC);
    wtDebug("Channel registered");
end

function chatglobmsg(txt)
    SendChatMessage(txt..validateString, "CHANNEL", nil, GetChannelName(wintertimeGC))
end

function WinterTime_UpdateGlobal(newTime)
    --if syncTimer < 0 then
        SendChatMessage(status..":"..newTime..":"..control..validateString, "CHANNEL", nil, GetChannelName(wintertimeGC))
    --end
end

function WinterTime_MouseOn()
	WTFormCloseButton:Show();
	WTAnnounceButton:Show();
	TitleText:SetText("Wintergrasp    ");
end

function WinterTime_MouseOff(hide)
    if hide then
        --chatmsg("True")
    else
        --chatmsg("False")
        hide = false;
    end
    
    if not(hide) and GetMouseFocus() == nil then
        return;
    end
    
    local fn = " "
    
    if not(hide) then
        fn = GetMouseFocus():GetName();
    end
    
    if fn == nil then
        fn = " ";
    end
    
    
    if hide == true or (fn ~= "WTAnnounceButton" and fn ~= "WTAnnounceButtonButton" and string.find(fn, "DropDownList")==nil) then
        WTFormCloseButton:Hide();
        WTAnnounceButton:Hide();
        TitleText:SetText("Wintergrasp");
    end
end

function WTAnnounceButton_Click()
    UIDropDownMenu_SetSelectedValue(this.owner, this.value);

    WinterTime_MouseOff(true);

    if (announceDelay > 0) then
        chatmsg("[WINTERTIME] You can not announce again yet.");
        chatmsg("You have to wait "..announceDelay.." seconds.");
        UIDropDownMenu_ClearAll(this.owner);
        return;
    end

    announceDelay = 20;
    
    local mess = "";

    if (trem>0) then
--        if (status == "Next") then
--            mess = "[WAPNER] Wintergrasp battle in "..convertTime(trem)..".";
--        else
--           mess = "[WAPNER] Wintergrasp battle currently in Progress, "..convertTime(trem).." remaining.";
--        end
    else
        UIDropDownMenu_ClearAll(this.owner);
        return;
    end

    if (this.value == 0) then
        WinterTime_GuildAnnounce("time");
    elseif (this.value == 1) then
        WTsendMessage("RAID")
        --SendChatMessage(mess, "RAID");
    elseif (this.value == 2) then
        WTsendMessage("PARTY")
        --SendChatMessage(mess, "PARTY");'
    elseif (this.value == 3) then
        id, name = GetChannelName("Trade - City");
        if (id > 0 and name ~= nil) then
            WTsendMessage("channel", id)
        end
    elseif (this.value == 4) then
        id, name = GetChannelName(1);
        if (id > 0 and name ~= nil) then
            WTsendMessage("channel", id)
        end
    end
    
    UIDropDownMenu_ClearAll(this.owner)
end

function WinterTime_GuildAnnounce(arg1)
    if (GetGuildInfo("player") ~= nil) then
        if (arg1 == "time") then
            WTsendMessage("GUILD");
--            if (trem>0) then
--                if (status == "Next") then
--                    SendChatMessage("[WAPNER] Battle in "..convertTime(trem)..".", "GUILD");
--                else
--                    SendChatMessage("[WAPNER] Battle currently in Progress, "..convertTime(trem).." remaining.", "GUILD");
--                end
--            end
        end
    end
end

function wtDebug(msg)
    if debug then
        chatmsg(msg)
    end
end

function WinterTime_OnEvent()

    if event == "WORLD_MAP_UPDATE" then

        mapUpdateDelay = mapUpdateDelay+1;
        if mapUpdateDelay >10 then
            mapUpdateDelay = 1
        end
        
        if mapUpdateDelay>1 then 
            return;
        end
        --wtDebug(GetNumMapLandmarks())
        for n=1,GetNumMapLandmarks() do
            name, description, texture = GetMapLandmarkInfo(n);

            if name == "Wintergrasp" then
                wtDebug(n)
                if texture == 46 then
                    if control == "" then
                        syncTimer = 5;
                    end
                    control = "Alliance";
                    wtDebug("Alliance detected")
                elseif texture == 48 then
                    if control == "" then
                        syncTimer = 5;
                    end
                    control = "Horde";
                    wtDebug("Horde detected")
                else
                    control = ""
                    wtDebug("Must be a battle going on");
                end
                --arg3, 48 = horde, 46 = alliance, 110 = Battle
            end
        end
    end
    
    if (event == "HONOR_CURRENCY_UPDATE") then
        WTHonorCount:SetText(GetHonorCurrency() - wtStartHonor);
        if GetHonorCurrency() == 75000 then
            WTHonorCount:SetText("MAX");
        end
    end
    
    if (event == "PLAYER_PVP_KILLS_CHANGED") then
        WTKillCount:SetText(GetPVPLifetimeStats()-wtStartKill);
    end

    if (event == "PLAYER_LOGOUT") then
        wtDebug("PLAYER_LOGOUT");
        LeaveChannelByName(wintertimeGC);
    end

    if (trem == nil) then
        trem = 0;
        wtDebug(event.." trem = nil");
    end

	if (event == "PLAYER_ENTERING_WORLD") then
		--chatmsg("PLAYER_ENTERING_WORLD");
	end

	if (event == "PLAYER_LOGIN") then
		loadTimer = 10;
	end

	if (event == "GOSSIP_SHOW") then
		txt = GetGossipText();
		if (string.find(txt, "The next battle begins in ")) then            
            wtDebug("New Time");
            if (string.find(txt, "Alliance")) then
                if (string.find(txt, "When")) then
                    control = "Horde";
                else
                    control = "Alliance";
                end
            end
            if (string.find(txt, "Horde")) then
                if (string.find(txt, "When")) then
                    control = "Alliance";
                else
                    control = "Horde";
                end
            end
            txt = ":"..strsub(txt, strlen(txt)-8)
			status = "Next";
            extractTime(txt);
		end
	end

	if (event == "CHAT_MSG_MONSTER_YELL") then
		if (string.find(arg1, "Wintergrasp")) then
			if (string.find(arg1, " 15 minutes")) then
				wtDebug("New Time");

				if (trem < 0) then
					trem = 15*60+2
				else
					trem = 15*60-1;
				end
				status = "Next";
				WinterTime_UpdateGlobal(trem);
			end 
			if (string.find(arg1, " 5 minutes")) then
				wtDebug("New Time");

				if (trem < 0) then
					trem = 5*60+2
				else
					trem = 5*60-1;
				end
				status = "Next";
				WinterTime_UpdateGlobal(trem);
			end
			if (string.find(arg1, "hour")) then
				wtDebug("New Time");
				if (trem < 0) then
					trem = 60*60+2
				else
					trem = 60*60-1;
				end
				status = "Next";
				WinterTime_UpdateGlobal(trem);
			end
		end
	end

	if (event =="CHAT_MSG_GUILD") then
		arg1 = strlower(arg1);
        if ((arg1 == "!wg") or (arg1=="!wt")) then
            guildmsg(generateMessage());
		end
	end
    
    if (event == "CHAT_MSG_WHISPER") then
    	arg1 = strlower(arg1);
        if ((arg1 == "!wg") or (arg1=="!wt")) then
            WTsendMessage("whisper", arg2);
		end
    end

	if (event == "CHAT_MSG_CHANNEL_NOTICE") then
		if (arg9 == "LocalDefense - Wintergrasp") then
            wtDebug("Detected Wintergrasp");
			zoneTimer=3;
		end
	end
    
    if(event == "CHAT_MSG_CHANNEL")then
		if(arg9 == wintertimeGC)then
            if (string.find(arg1, validateString))then
                arg1 = strsub(arg1,1,strlen(arg1)-strlen(validateString));
                wtDebug(arg1..arg2..arg3..arg4..arg5);

                if (arg1=="sync") then
                    --local a = timeBetween(endTime, serverTimeSeconds());
                    if (arg2 == UnitName("player")) then
                        syncSent = true;
                    end
                    
                    local a = trem;
                    if (a > 0) then
                        SendAddonMessage("WintergraspT", status..":"..a..":"..control, "WHISPER", arg2);
                    end
                elseif (string.find(arg1, "version:")) then
                    SendAddonMessage("WintergraspT", "v:"..version, "WHISPER", arg2);
                else
                    syncTimer = 5*60+math.random(0, 60);
                    updateTimer(arg1)
                    
--                    local a, b, c = strsplit(":", arg1);
--                    status = a;
--                    trem = tonumber(b);
--                    if (c==nil) then
--                        chatmsg("c = nil");
--                    else
--                        chatmsg("c = "..c);
--                    end
--                    control = c;
--                    endTime = endTimeServer(trem);
                end
            else
                wtDebug("Invalid WINTERTIME chat detected.");
                wtDebug(arg2.." sent '"..arg1.."'");
                
                if (arg2==UnitName("player")) then
                    chatmsg("Unauthorized -"..wintertimeGC.."- text");
                    chatmsg("This channel is used only by WINTERTIME.");
                end
            end
		end
	end

	if (event == "CHAT_MSG_ADDON") then
		if (arg1 == "WintergraspT") then
			if (arg2=="name") then
                if (WinterTimeGuildA == 1) then
				    SendAddonMessage("WintergraspT", "n:"..UnitName("player"), "WHISPER", arg4);
                else
                    wtDebug("Guild announce disabled, no name sent");
                end
            elseif (string.find(arg2, "n:")) then
				a=strsub(arg2,3);
				table.insert(guildTable, 1, a);
			elseif (string.find(arg2, "v:")) then
                local ov = tonumber(strsub(arg2,3));
                if (ov > tonumber(newver)) then
                    newver = ov;
                end
                
                if (verDisplay == true) then
                    vCount = vCount + 1;
				    chatmsg(vCount..". ".." "..strsub(arg2,3).. "  "..arg4);
                end
            else
                updateTimer(arg2)
			end
			wtDebug(arg1.." : "..arg2.." : "..arg3.." : "..arg4);
		end
	end
end

function chatmsg(a)
	DEFAULT_CHAT_FRAME:AddMessage(a);
end

function battleType()
    englishFaction, localizedFaction = UnitFactionGroup("player");
    local otherFaction = " "
    if englishFaction == "Horde" then
        otherFaction = "Alliance";
    elseif englishFaction == "Alliance" then
        otherFaction = "Horde";
    end

    if (englishFaction == control) then
        return "defensive ";
    elseif (otherFaction == control) then
        return "offensive ";
    else
        return "";
    end
end

function generateMessage(timer)
    
    if timer == nil then
        timer = trem;
    end
    
    if (timer>0) then
        if (status == "Next") then
            return "[WAPNER] Wintergrasp "..battleType().."battle in "..convertTime(timer)..".";
        else
            return "[WAPNER] Wintergrasp "..battleType().."battle currently in Progress, "..convertTime(timer).." remaining.";
        end
    else
        return "[WinterTime] No valid time. Recomend you download the addon.";
    end
end

function WTsendMessage(type, name, message)
    local msg = "";

    if message == nil then
        msg = generateMessage();
    else
        msg = message;
    end
    
    SendChatMessage(msg, type, nil, name);
    
    if (type == "whisper") then
        --SendChatMessage(msg, "WHISPER", nil, name);
    elseif (type == "guild") then
        
    end
    
end

function timeToNumber(txt)
    --chatmsg("Extracting '"..txt.."'");
    local a, b, c, d = strsplit(":", txt);
    local thour = tonumber(b);
    local tmin = tonumber(c);
    local tsec = tonumber(d);
    
    if (tsec >60 ) then
        tsec = tsec /10;
    end
    
	return tonumber((thour *60*60 + tmin *60 + tsec));
end

function serverTimeSeconds()
    --local hour, minute, second = WinterTime_GameTime:Get()

    --second = ceil(second);
    
    --return timeToNumber(":"..hour..":"..minute..":"..second)
    
    return ceil(GetTime());
end

function endTimeServer(timeSec)

    local atrem = ceil(timeSec * timerOffset);

    local eTime = serverTimeSeconds() + atrem;

    --if eTime > (24*60*60) then
    --    eTime = eTime - (24*60*60);
    --end

    --return convertTime(eTime).."   "..convertTime(trem).."   "..hour..":"..minute..":"..second;
    return eTime;
end

function extractTime(txt)
    WinterTime_UpdateGlobal(timeToNumber(txt));
end

function guildmsg(arg1)
	guildText = arg1;	
	guildDelay = 2;
	guildTable = {};
    if (GetGuildInfo("player") ~= nil) then
	    SendAddonMessage("WintergraspT", "name", "GUILD");
    end
end

function WinterTime_Scale()
    WTForm:SetScale(WTOptionsSliderScale:GetValue());
    WinterTimeScale = WTOptionsSliderScale:GetValue()
    if WTLabel then
        WTLabel:SetScale(WTOptionsSliderScale:GetValue());
    end
end

function WinterTime_Alpha()
    WTForm:SetAlpha(WTOptionsSliderAlpha:GetValue()/100);
    WinterTimeAlpha = WTOptionsSliderAlpha:GetValue();
end

function WinterTime_CheckButton()
    if (WTOptionsCheckButton:GetChecked()==1) then
        WinterTimeCheck = 1;
    else
        WinterTimeCheck = 0;
    end
end

function WinterTime_GuildCheck()
    if (WTOptionsGuildCheck:GetChecked()==1) then
        WinterTimeGuildA = 1;
    else
        WinterTimeGuildA = 0;
    end
end


function WinterTime_LockMove()
    if (WTOptionsLockMove:GetChecked()==1) then
        WinterTimeLockMovement = 1;
    else
        WinterTimeLockMovement = 0;
    end
end

function WinterTime_ShowColor()
    if (WTOptionsShowColor:GetChecked()==1) then
        WinterTimeShowColor = 1;
    else
        WinterTimeShowColor = 0;
    end
end

function WinterTime_ShowPVPTab()
    if (WTOptionsShowPVPTab:GetChecked()==1) then
        WinterTimePVPTab = 1;
    else
        WinterTimePVPTab = 0;
    end
end

function WinterTime_DragStart()
    if (WinterTimeLockMovement == 0) then
        WTForm:StartMoving();
        WTForm.isMoving = true;
    else
        chatmsg("|c003333ffWINTERTIME:|r Timer frame is locked, Unlock in options to move.")
    end
end

function WinterTime_DragStop()
    WTForm:StopMovingOrSizing();
    WTForm.isMoving = false;
end

function updateTimer(arg)
    local cc = control;
    local a, b, c = strsplit(":", arg);
    if (status == "Battle") and (a == "Next") then
        cc = ""
    end
    
    if (c==nil or c == "") then
        c = cc;
    end

    status = a;
    trem = tonumber(b);

    if (trem ==0) then 
        trem = 1;
    end
    
    control = c;

    endTime = endTimeServer(trem);
end

function timeBetween(t1, t2)
    local tb = 0;
    tb = t1-t2;
    if tb <0 then
        tb = (t1+(24*60*60)) - t2;
        if tb > (2.5*60*60) then
            return 0;
        end
    end
    return tb;
end

function convertTime(numTime)
	local tmp = numTime %(60*60);
	local thour = (numTime -tmp)/60/60;
	local tsec = tmp %60;
	local tmin = (tmp -tsec)/60;
	local ttxt = thour..":";
    
    local shour = tostring(thour);
    local smin = tostring(tmin);
    local ssec = tostring(tsec);
    
	if (strlen(smin) == 1) then
		smin = "0"..smin;
	end
	if (strlen(ssec) == 1) then
		ssec = "0"..ssec;
	end
	ttxt = shour..":"..smin..":"..ssec;
    return ttxt;
end

function convertDate()
    weekday, month, day, year = CalendarGetDate();

    chatmsg(month);
    chatmsg(day);
    chatmsg(year);
end

function Wintertime_color_function()
    local R,G,B = ColorPickerFrame:GetColorRGB();
    WTLabel:SetTextColor(R, G, B);
    WTTextColorR = R;
    WTTextColorG = G;
    WTTextColorB = B;
    wtDebug(R.."   "..G.."   "..B);
end

ColorPickerFrame.func = Wintertime_color_function

function WinterTime_Handler(msg)


    if (msg == "debug version") then
        debug = true;
        msg = "version";
    end

	if (msg == "version") then
		if (debug == true) then
            debug = false;
            vCount = 0;
            verDisplay = true;
            chatglobmsg("version:"..version);
            chatmsg("--Version Check--")
        else
            chatmsg("|c003333ff[WINTERTIME]|r Version "..version.." installed.");
        end
    elseif (msg == "timer") then
        WTLabel:Show();
        WTForm:Show();
        msg ="";
	elseif (msg == "debug") then
		debug = not(debug);
		if (debug == true) then
			chatmsg("Debug mode: Enabled");
		else
			chatmsg("Debug mode: Disabled");
		end
	elseif (msg == "") then
		if (trem > 0) then
            if (status == "Next") then
                chatmsg("|c003333ff[Wintergrasp]|r Battle in "..convertTime(trem)..".");
            else
                chatmsg("|c003333ff[Wintergrasp]|r Battle currently in Progress, "..convertTime(trem).." remaining.");
            end
		else
			chatmsg("|c00cc0000No valid time for Wintergrasp.|r");
		end
    elseif (msg == "lm" and debug) then
    
        wtDebug(GetNumMapLandmarks())
        for n=1,GetNumMapLandmarks() do
            name, description, texture = GetMapLandmarkInfo(n);
            wtDebug(n.." : "..name.." : "..description.." : "..texture);
            
        end
        
--    elseif (msg == "guild") then
--        WinterTime_GuildAnnounce("time");
----    elseif (string.find(msg, "scale ")) then
----        local a, b = strsplit(" ", msg);
----        if (tonumber(b)>2) then
----            b=2;
----            chatmsg("|c003333ffWINTERTIME:|r Max resize is 2");
----        elseif (tonumber(b)<.5) then
----            b=.5;
----            chatmsg("|c003333ffWINTERTIME:|r Min resize is .5");
----        end
----        WTForm:SetScale(b);
----        WinterTimeScale = b;
--    elseif (msg == "ws") then
--    --uiType, state, text, icon, isFlashing, dynamicIcon, tooltip, dynamicTooltip, extendedUI, extendedUIState1, extendedUIState2, extendedUIState3 = GetWorldStateUIInfo(1);
--    arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12 = GetWorldStateUIInfo(1);
--    chatargs();
--    arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12 = GetWorldStateUIInfo(1);
--    chatargs();
--    arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12 = GetWorldStateUIInfo(2);
--    chatargs();
--    arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12 = GetWorldStateUIInfo(3);
--    chatargs();
--    arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12 = GetWorldStateUIInfo(4);
--    chatargs();
--    arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12 = GetWorldStateUIInfo(5);
--    chatargs();
--    arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12 = GetWorldStateUIInfo(6);
--    chatargs();
--    arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12 = GetWorldStateUIInfo(7);
--    chatargs();
--    arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12 = GetWorldStateUIInfo(8);
--    chatargs();
--    arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12 = GetWorldStateUIInfo(9);
--    chatargs();
--    elseif (msg == "fn") then
--            chatmsg( "The mouse is over " .. GetMouseFocus():GetName() );
--    elseif (string.find(msg, "trem")) then
--        local a, b, c = strsplit(" ", msg);
--        endTime = endTimeServer(tonumber(b))
--    elseif (string.find(msg, "tb")) then
--        local a, b, c = strsplit(" ", msg);
--        a= timeBetween(tonumber(b), tonumber(c));
--        chatmsg(a);
--        chatmsg(convertTime(a));

    elseif (msg == "reset") then
        WTOptions:ClearAllPoints();
        WTOptions:SetPoint("CENTER", "UIParent");
        WTForm:ClearAllPoints();
        WTForm:SetPoint("CENTER", "UIParent");
        WTForm:SetScale(1);
        WinterTimeScale = 1;
        WTOptionsSliderScale:SetValue(WinterTimeScale);
        WinterTimeAlpha = 100;
        WTOptionsSliderAlpha:SetValue(WinterTimeAlpha);
        WinterTimeCheck = 1;
        WTOptionsCheckButton:SetChecked(true);
        WinterTimeGuildA = 1;
        WTOptionsGuildCheck:SetChecked(true);
        WinterTimeLockMovement = 0;
        WTOptionsLockMove:SetChecked(false);
        WTTextColorR = 1;
        WTTextColorG = 1;
        WTTextColorB = 1;
        WTLabel:SetTextColor(1, 1, 1);
        WinterTimePVPTab = 1;
        WTOptionsShowPVPTab:SetChecked(true);
        WTLabel:Show();
        WTForm:Show();
    elseif (msg == "options") then
        WTOptions:Show();
    elseif (msg == "sync") then
        chatmsg("Attempting to sync with other players....");
        chatglobmsg("sync");
--    elseif (msg == "color") then
--        ColorPickerFrame:Show();
--    elseif (msg == "time" and debug) then
--        hour, minute, second = WinterTime_GameTime:Get()
--        chatmsg(hour.." "..minute.." "..second);
--    elseif msg == "pvp" then
--        WTFormPVP:Show();
--        WTFormPVP:SetHeight(80);
    else
        chatmsg("|c003333ffWINTERTIME:|r  Global timer for Wintergrasp battles.");
        chatmsg("|c003333ffWINTERTIME:|r  --Command Line options--");
        chatmsg("|c003333ffWINTERTIME:|r  /wt {guild | options | reset | scale (scale) | timer | version}");
        chatmsg("|c003333ffWINTERTIME:|r  /wt             'Displays current time'");
        chatmsg("|c003333ffWINTERTIME:|r    -  guild     'Announces time in guild chat.'");
        chatmsg("|c003333ffWINTERTIME:|r    -  options    'Opens the options GUI'");
        chatmsg("|c003333ffWINTERTIME:|r    -  reset     'Resets the timer to defaults'");
--        chatmsg("|c003333ffWINTERTIME:|r    -  scale (scale) 'Scales the frame (2 - .5)'");
        chatmsg("|c003333ffWINTERTIME:|r    -  timer     'Displays timer frame.'");
        chatmsg("|c003333ffWINTERTIME:|r    -  version 'Installed Version'");
	end
end

function WinterTimeAnnounceDD_Initialise()
 level = level or 1
 
 local info = UIDropDownMenu_CreateInfo();

 info.text = "GUILD"; 
 info.value = 0; 
 info.func = function() WTAnnounceButton_Click() end;
 info.owner = this:GetParent();
 info.checked = nil;
 info.icon = nil; 
 UIDropDownMenu_AddButton(info, level);

 info.text = "RAID";
 info.value = 1;
 info.func = function() WTAnnounceButton_Click() end;
 info.owner = this:GetParent();
 info.checked = nil;
 info.icon = nil;
 UIDropDownMenu_AddButton(info, level);
 
  info.text = "PARTY";
 info.value = 2;
 info.func = function() WTAnnounceButton_Click() end;
 info.owner = this:GetParent();
 info.checked = nil;
 info.icon = nil;
 UIDropDownMenu_AddButton(info, level);
 
  info.text = "TRADE";
 info.value = 3;
 info.func = function() WTAnnounceButton_Click() end;
 info.owner = this:GetParent();
 info.checked = nil;
 info.icon = nil;
 UIDropDownMenu_AddButton(info, level);
 
  info.text = "GENERAL";
 info.value = 4;
 info.func = function() WTAnnounceButton_Click() end;
 info.owner = this:GetParent();
 info.checked = nil;
 info.icon = nil;
 UIDropDownMenu_AddButton(info, level);
end